// OcvitaBarcodeCtrl.cpp : Implementation of the COcvitaBarcodeCtrl ActiveX Control class.

#include "stdafx.h"
#include "OcvitaBarcode.h"
#include "OcvitaBarcodeCtrl.h"
#include "OcvitaBarcodePropPage.h"
#include "OcvitaBarcodePropPage2.h"
#include "OcvitaBarcodePropPage3.h"
#include "OcvitaBarcodePropPage4.h"

#include "Zint\zint.h"
#include <cmath>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(COcvitaBarcodeCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(COcvitaBarcodeCtrl, COleControl)
	//ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(COcvitaBarcodeCtrl, COleControl)
	DISP_FUNCTION_ID(COcvitaBarcodeCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "symbology", dispidsymbology, Getsymbology, Setsymbology, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "barcode", dispidbarcode, Getbarcode, Setbarcode, VT_BSTR)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "height", dispidheight, Getheight, Setheight, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "whitespace_width", dispidwhitespace_width, Getwhitespace_width, Setwhitespace_width, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "border_width", dispidborder_width, Getborder_width, Setborder_width, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "output_options", dispidoutput_options, Getoutput_options, Setoutput_options, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "fgcolour", dispidfgcolour, Getfgcolour, Setfgcolour, VT_BSTR)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "bgcolour", dispidbgcolour, Getbgcolour, Setbgcolour, VT_BSTR)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "option_1", dispidoption_1, Getoption_1, Setoption_1, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "option_2", dispidoption_2, Getoption_2, Setoption_2, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "option_3", dispidoption_3, Getoption_3, Setoption_3, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "scale", dispidscale, Getscale, Setscale, VT_R4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "input_mode", dispidinput_mode, Getinput_mode, Setinput_mode, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "hrtext", dispidhrtext, Gethrtext, Sethrtext, VT_BSTR)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "rows", dispidrows, Getrows, Setrows, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "width", dispidwidth, Getwidth, Setwidth, VT_I4)
	DISP_FUNCTION_ID(COcvitaBarcodeCtrl, "get_encoded_data", dispidget_encoded_data, get_encoded_data, VT_UI1, VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(COcvitaBarcodeCtrl, "get_row_height", dispidget_row_height, get_row_height, VT_I4, VTS_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "errtxt", dispiderrtxt, Geterrtxt, Seterrtxt, VT_BSTR)
	DISP_FUNCTION_ID(COcvitaBarcodeCtrl, "get_bitmap", dispidget_bitmap, get_bitmap, VT_I1, VTS_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "bitmap_width", dispidbitmap_width, Getbitmap_width, Setbitmap_width, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "bitmap_height", dispidbitmap_height, Getbitmap_height, Setbitmap_height, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "primary", dispidprimary, Getprimary, Setprimary, VT_BSTR)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "rotate_angle", dispidrotate_angle, Getrotate_angle, Setrotate_angle, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "code_page", dispidcode_page, Getcode_page, Setcode_page, VT_I4)
	DISP_PROPERTY_EX_ID(COcvitaBarcodeCtrl, "setting_1", dispidsetting_1, Getsetting_1, Setsetting_1, VT_I4)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(COcvitaBarcodeCtrl, COleControl)
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(COcvitaBarcodeCtrl, 4)
	PROPPAGEID(COcvitaBarcodePropPage::guid)
	PROPPAGEID(COcvitaBarcodePropPage2::guid)
	PROPPAGEID(COcvitaBarcodePropPage4::guid)
	PROPPAGEID(COcvitaBarcodePropPage3::guid)
END_PROPPAGEIDS(COcvitaBarcodeCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(COcvitaBarcodeCtrl, "Ocvita.Barcode",
	0x8d389c31, 0x9b29, 0x404d, 0xa3, 0x1b, 0xb8, 0x19, 0xa4, 0xf1, 0x43, 0xfd)



// Type library ID and version

IMPLEMENT_OLETYPELIB(COcvitaBarcodeCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DOcvitaBarcode =
		{ 0x4EB32950, 0x3748, 0x47B2, { 0x81, 0xD2, 0xEA, 0x55, 0x83, 0x8, 0x67, 0x3C } };
const IID BASED_CODE IID_DOcvitaBarcodeEvents =
		{ 0x99D8CB02, 0xE221, 0x4419, { 0x95, 0x6E, 0x84, 0x95, 0x67, 0x11, 0xC0, 0x7A } };



// Control type information

static const DWORD BASED_CODE _dwOcvitaBarcodeOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(COcvitaBarcodeCtrl, IDS_OCVITABARCODE, _dwOcvitaBarcodeOleMisc)



// COcvitaBarcodeCtrl::COcvitaBarcodeCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for COcvitaBarcodeCtrl

BOOL COcvitaBarcodeCtrl::COcvitaBarcodeCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_OCVITABARCODE,
			IDB_OCVITABARCODE,
			afxRegInsertable | afxRegApartmentThreading,
			_dwOcvitaBarcodeOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// COcvitaBarcodeCtrl::COcvitaBarcodeCtrl - Constructor

COcvitaBarcodeCtrl::COcvitaBarcodeCtrl()
{
	InitializeIIDs(&IID_DOcvitaBarcode, &IID_DOcvitaBarcodeEvents);
	// TODO: Initialize your control's instance data here.

	symbol = ZBarcode_Create();
	//      
	barcode = _T("2");
	symbology = 20;
	height = 50;
	whitespace_width = 0;
	border_width = 0;
	output_options = 0;
	fgcolour = _T("000000");
	bgcolour = _T("ffffff");
	outfile = _T("2.bmp");
	option_1 = 0;
	option_2 = 0;
	option_3 = 0;
	scale = 1.0;
	input_mode = DATA_MODE;
	primary = _T("");
	hrtext = _T("");
	rotate_angle = 0;
	code_page = CP_UTF8;
	setting_1 = 0;
}



// COcvitaBarcodeCtrl::~COcvitaBarcodeCtrl - Destructor

COcvitaBarcodeCtrl::~COcvitaBarcodeCtrl()
{
	// TODO: Cleanup your control's instance data here.
	ZBarcode_Delete(symbol);
}



// COcvitaBarcodeCtrl::OnDraw - Drawing function

void COcvitaBarcodeCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if (!pdc)
		return;

	int error = 0;

	//  
	symbol->symbology			= symbology;
	symbol->height				= height;
	symbol->whitespace_width	= whitespace_width;
	symbol->border_width		= border_width;
	symbol->output_options		= output_options;

	//    

	//WideCharToMultiByte(CP_ACP, 0, fgcolour, -1, (LPSTR)zint_symbol->fgcolour, 7, NULL, NULL);
	//WideCharToMultiByte(CP_ACP, 0, bgcolour, -1, (LPSTR)zint_symbol->bgcolour, 7, NULL, NULL);

	//  - ???
	WideCharToMultiByte(CP_ACP, 0, outfile, -1, (LPSTR)(symbol->outfile), 255, NULL, NULL);

	symbol->option_1 = option_1;
	symbol->option_2 = option_2;
	symbol->option_3 = option_3;
	symbol->scale = scale;
	symbol->input_mode = input_mode;
	symbol->show_hrt = 1; // Show human readable text
	symbol->setting_1 = setting_1;

	//  - ???
	if (code_page == 0)
		code_page = CP_UTF8;

	WideCharToMultiByte(code_page, 0, primary, -1, (LPSTR)(symbol->primary), 127, NULL, NULL);

	ZBarcode_Clear(symbol);

	//int sizeOfString = (barcode.GetLength() + 1);
	//LPTSTR lpsz = new TCHAR[sizeOfString];
	//_tcscpy_s(lpsz, sizeOfString, barcode);
	//ZBarcode_Encode(symbol, (unsigned char*)lpsz, 0);
	//unsigned char buf[1000];

	int buf_size = barcode.GetLength() * 4 + 4; //barcode.GetLength() * 4 + 1;
	unsigned char *buf = new unsigned char[buf_size];
	
	//      
	WideCharToMultiByte(code_page, 0, barcode, -1, (LPSTR)buf, buf_size, NULL, NULL);

	//   ,    EAN-8  EAN-13,
	//    
	if (symbology == BARCODE_EANX)
	{
		char TestCode[14];
		if (barcode.GetLength() == 8)
		{
			strncpy_s(TestCode, 13, (char *)buf, 7);
			if (upc_check(TestCode) == buf[7])
				buf[7] = '\0';
			else
				error = 1;
		}
		if (barcode.GetLength() == 13)
		{
			strncpy_s(TestCode, 13, (char *)buf, 12);
			if (ean_check(TestCode) == buf[12])
				buf[12] = '\0';
			else
				error = 1;
		}
	}
	
	if (!error)
	{
		error = ZBarcode_Encode(symbol, buf, 0);
		delete []buf;
	}

	if (error == 0) {
		ZBarcode_Buffer(symbol, rotate_angle);
	}

	// brush definition
	CBrush bb, fb; // background, foreground brushes

	DWORD str_int = 0x00ffffff;
	if (bgcolour.GetLength() == 6)
	{
		for (int i = 0; i < bgcolour.GetLength(); i++)
		{
			if (bgcolour.Mid(i,1).FindOneOf(_T("0123456789ABCDEFabcdef")) == -1)
			{
				error = 1;
				break;
			}
		}
		if (!error)
		{
			CString TempString = _T("0x00") + bgcolour;
			char bbcolour[12];
			WideCharToMultiByte(CP_UTF8, 0, TempString, -1, (LPSTR)bbcolour, 11, NULL, NULL);

			sscanf_s(bbcolour, "%10i", &str_int);
		}
	}
	bb.CreateSolidBrush(str_int);
	//bb.CreateSolidBrush(RGB(255,255,255));

	str_int = 0x00000000;
	if (fgcolour.GetLength() == 6)
	{
		for (int i = 0; i < fgcolour.GetLength(); i++)
		{
			if (fgcolour.Mid(i,1).FindOneOf(_T("0123456789ABCDEFabcdef")) == -1)
			{
				error = 1;
				break;
			}
		}
		if (!error)
		{
			CString TempString = _T("0x00") + fgcolour;
			char fbcolour[12];
			WideCharToMultiByte(CP_UTF8, 0, TempString, -1, (LPSTR)fbcolour, 11, NULL, NULL);

			sscanf_s(fbcolour, "%10i", &str_int);
		}
	}
	fb.CreateSolidBrush(str_int);
	
	bool TransparentBackgroung = (bgcolour.GetLength() == 0);
	// pdc->Ellipse(rcBounds);

	//    
	int resampleFactor;
	resampleFactor = min(rcBounds.Width()  / symbol->bitmap_width,
						rcBounds.Height() / symbol->bitmap_height);
	if (resampleFactor == 0)
		error = 1;

	if (error != 0) {
		//    5%       5%
		//     ,    1 

		pdc->FillRect(rcBounds, &fb);
		if (rcBounds.Width() < 3 || rcBounds.Height() < 3)
			return;

		int ew;
		ew = max(min(rcBounds.Width(), rcBounds.Height()) * 0.05, 1);

		CRect erect;
		erect = rcBounds;
		erect.DeflateRect(ew, ew);

		pdc->FillRect(erect, &bb);

		//  
		CPoint eline[6];
		eline[0].x = erect.left;
		eline[0].y = erect.top;
		eline[1].x = erect.left + ew;
		eline[1].y = erect.top;
		eline[2].x = erect.right;
		eline[2].y = erect.bottom - ew;
		eline[3].x = erect.right;
		eline[3].y = erect.bottom;
		eline[4].x = erect.right - ew;
		eline[4].y = erect.bottom;
		eline[5].x = erect.left;
		eline[5].y = erect.top + ew;

		CRgn ergn;
		ergn.CreatePolygonRgn(eline, 6, ALTERNATE);
		pdc->FillRgn(&ergn, &fb);

		eline[0].x = erect.right;
		eline[0].y = erect.top;
		eline[1].x = erect.right;
		eline[1].y = erect.top + ew;
		eline[2].x = erect.left + ew;
		eline[2].y = erect.bottom;
		eline[3].x = erect.left;
		eline[3].y = erect.bottom;
		eline[4].x = erect.left;
		eline[4].y = erect.bottom - ew;
		eline[5].x = erect.right - ew;
		eline[5].y = erect.top;

		CRgn ergn2;
		ergn2.CreatePolygonRgn(eline, 6, ALTERNATE);
		pdc->FillRgn(&ergn2, &fb);

		return;
	}

	if (!TransparentBackgroung)
		pdc->FillRect(rcBounds, &bb);
	pdc->SetPolyFillMode(ALTERNATE);
	pdc->SetROP2(R2_COPYPEN);
	pdc->SetStretchBltMode(COLORONCOLOR);


	int bx, by; //  
	bx = rcBounds.left + (rcBounds.Width() - symbol->bitmap_width * resampleFactor) / 2;
	by = rcBounds.top + (rcBounds.Height() - symbol->bitmap_height * resampleFactor) / 2;

	CRect rect;
	int i = 0, red;
	for(int row = 0; row < symbol->bitmap_height; row++) {
		for(int col = 0; col < symbol->bitmap_width; col++) {
            red = symbol->bitmap[i];
            //green = my_symbol->bitmap[i + 1];
            //blue = my_symbol->bitmap[i + 2];
			rect.top = by + resampleFactor * row;
			rect.bottom = rect.top + resampleFactor;
			rect.left = bx + resampleFactor * col;
			rect.right = rect.left + resampleFactor;
			if (red) {
				if (!TransparentBackgroung)
					pdc->FillRect(rect, &bb);
			}
			else
			{
				pdc->FillRect(rect, &fb);
			}
	        i += 3;
        }
	}

}



// COcvitaBarcodeCtrl::DoPropExchange - Persistence support

void COcvitaBarcodeCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
	PX_String(pPX, _T("barcode"), barcode, _T("123456"));

	PX_Long(pPX, _T("symbology"), symbology, 20);
	PX_Long(pPX, _T("height"), height, 50);
	PX_Long(pPX, _T("whitespace_width"), whitespace_width, 0);
	PX_Long(pPX, _T("border_width"), border_width, 0);
	PX_Long(pPX, _T("output_options"), output_options, 0);

	PX_String(pPX, _T("fgcolour"), fgcolour, _T("000000"));
	PX_String(pPX, _T("bgcolour"), bgcolour, _T("ffffff"));
	PX_String(pPX, _T("outfile"), outfile, _T("out.bmp"));

	PX_Long(pPX, _T("option_1"), option_1, 0);
	PX_Long(pPX, _T("option_2"), option_2, 0);
	PX_Long(pPX, _T("option_3"), option_3, 0);

	PX_Float(pPX, _T("scale"), scale, 1.0);

	PX_Long(pPX, _T("input_mode"), input_mode, 0);

	PX_String(pPX, _T("primary"), primary, _T(""));
	PX_String(pPX, _T("hrtext"), hrtext, _T(""));

	PX_Long(pPX, _T("rotate_angle"), rotate_angle, 0);
	
	if (pPX->GetVersion() >= MAKELONG(1,1)) {
		PX_Long(pPX, _T("code_page"), code_page, 65001);
		PX_Long(pPX, _T("setting_1"), setting_1, 0);
	}
	else {
		if (pPX->IsLoading()) {
			code_page = 65001;
			setting_1 = 0;
		}
	}
}



// COcvitaBarcodeCtrl::OnResetState - Reset control to default state

void COcvitaBarcodeCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// COcvitaBarcodeCtrl::AboutBox - Display an "About" box to the user

void COcvitaBarcodeCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_OCVITABARCODE);
	dlgAbout.DoModal();
}

DWORD COcvitaBarcodeCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();
	dwFlags |= noFlickerActivate;
	return dwFlags;
}


// COcvitaBarcodeCtrl message handlers

LONG COcvitaBarcodeCtrl::Getsymbology(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbology;
}

void COcvitaBarcodeCtrl::Setsymbology(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	symbology = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

BSTR COcvitaBarcodeCtrl::Getbarcode(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	//CString strResult;

	// TODO: Add your dispatch handler code here

	//strResult = barcode;

	return barcode.AllocSysString();
}

void COcvitaBarcodeCtrl::Setbarcode(LPCTSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	barcode = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getheight(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return height;
}

void COcvitaBarcodeCtrl::Setheight(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	height = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getwhitespace_width(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return whitespace_width;
}

void COcvitaBarcodeCtrl::Setwhitespace_width(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	whitespace_width = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getborder_width(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return border_width;
}

void COcvitaBarcodeCtrl::Setborder_width(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	border_width = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getoutput_options(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return output_options;
}

void COcvitaBarcodeCtrl::Setoutput_options(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	output_options = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

BSTR COcvitaBarcodeCtrl::Getfgcolour(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return fgcolour.AllocSysString();
}

void COcvitaBarcodeCtrl::Setfgcolour(LPCTSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	fgcolour = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

BSTR COcvitaBarcodeCtrl::Getbgcolour(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return bgcolour.AllocSysString();
}

void COcvitaBarcodeCtrl::Setbgcolour(LPCTSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	bgcolour = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getoption_1(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return option_1;
}

void COcvitaBarcodeCtrl::Setoption_1(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	option_1 = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getoption_2(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return option_2;
}

void COcvitaBarcodeCtrl::Setoption_2(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	option_2 = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getoption_3(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return option_3;
}

void COcvitaBarcodeCtrl::Setoption_3(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	option_3 = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

FLOAT COcvitaBarcodeCtrl::Getscale(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return scale;
}

void COcvitaBarcodeCtrl::Setscale(FLOAT newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	scale = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getinput_mode(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return input_mode;
}

void COcvitaBarcodeCtrl::Setinput_mode(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	input_mode = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

BSTR COcvitaBarcodeCtrl::Gethrtext(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return hrtext.AllocSysString();
}

void COcvitaBarcodeCtrl::Sethrtext(LPCTSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	hrtext = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getrows(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbol->rows;
}

void COcvitaBarcodeCtrl::Setrows(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

}

LONG COcvitaBarcodeCtrl::Getwidth(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbol->width;
}

void COcvitaBarcodeCtrl::Setwidth(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

}

BYTE COcvitaBarcodeCtrl::get_encoded_data(LONG x, LONG y)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbol->encoded_data[y][x];
}

LONG COcvitaBarcodeCtrl::get_row_height(LONG row)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbol->row_height[row];
}

BSTR COcvitaBarcodeCtrl::Geterrtxt(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString strResult(symbol->errtxt);

	// TODO: Add your dispatch handler code here

	return strResult.AllocSysString();
}

void COcvitaBarcodeCtrl::Seterrtxt(LPCTSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

}

CHAR COcvitaBarcodeCtrl::get_bitmap(LONG index)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbol->bitmap[index];
}

LONG COcvitaBarcodeCtrl::Getbitmap_width(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	//    
	return symbol->bitmap_width;
}

void COcvitaBarcodeCtrl::Setbitmap_width(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

}

LONG COcvitaBarcodeCtrl::Getbitmap_height(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here

	return symbol->bitmap_height;
}

void COcvitaBarcodeCtrl::Setbitmap_height(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

}

BSTR COcvitaBarcodeCtrl::Getprimary(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString strResult(primary);

	// TODO: Add your dispatch handler code here

	return strResult.AllocSysString();
}

void COcvitaBarcodeCtrl::Setprimary(LPCTSTR newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

}

LONG COcvitaBarcodeCtrl::Getrotate_angle(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return rotate_angle;
}

void COcvitaBarcodeCtrl::Setrotate_angle(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	rotate_angle = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getcode_page(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return code_page;
}

void COcvitaBarcodeCtrl::Setcode_page(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	code_page = newVal;
	InvalidateControl();
	SetModifiedFlag();
}

LONG COcvitaBarcodeCtrl::Getsetting_1(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return setting_1;
}

void COcvitaBarcodeCtrl::Setsetting_1(LONG newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	setting_1 = newVal;
	InvalidateControl();
	SetModifiedFlag();
}
